﻿#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=prog.ico
#AutoIt3Wrapper_Outfile=FlashTest-Slave.exe
#AutoIt3Wrapper_Outfile_x64=FlashTest-Slave64.exe
#AutoIt3Wrapper_Compile_Both=y
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Description=FlashTest-Slave
#AutoIt3Wrapper_Res_Fileversion=1.2.0.0
#AutoIt3Wrapper_Res_ProductName=FlashTest-Slave
#AutoIt3Wrapper_Res_ProductVersion=1.2.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Gorathan (admin@technik-hobby.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#NoTrayIcon
#include <APIFilesConstants.au3>
#include <APIProcConstants.au3>
#include <FileConstants.au3>
#include <Memory.au3>
#include <MemoryConstants.au3>
#include <Misc.au3>
#include <WinAPIFiles.au3>
#include <WinAPIHObj.au3>
#include <WinAPIInternals.au3>
#include <WinAPIProc.au3>
#include <WinAPISys.au3>

#include 'includes\MailSlot.au3'

#Region *** Konstanten deklarieren ***
Global Const $sAppTitle = 'FlashTest-Slave'
Global Const $sAppVersion = '1.2.0.0'
Global Const $sAppDate = '15.02.2020'
Global Const $sMailSlotServer = '\\.\mailslot\FlashTestServer'
Global Const $sMailSlotSlave = '\\.\mailslot\FlashTestSlave'
#EndRegion *** Konstanten deklarieren ***
_Singleton($sAppTitle)
If Not WinExists('FlashTest') Then
	Run(StringFormat('%s\FlashTest%s.exe', @ScriptDir, (@AutoItX64 ? '64' : '')))
	Exit
EndIf
Global $hMailSlot = _MailSlotCreate($sMailSlotSlave)
If @error Then Exit MsgBox(48 + 262144, 'MailSlotSlave', 'Failed to create new account!' & @CRLF & 'Probably one using that "address" already exists.')

_WinAPI_SetPriorityClass($HIGH_PRIORITY_CLASS)

; Der Assembler-Code steht am Ende von diesem Script
; Hier im Binaerformat
Global $__g_bASMCode, $__g_bASMCode2
If @AutoItX64 Then ; 64 Bit Version
    $__g_bASMCode = "0x575653554889CE4889D248D1EA4C89C04831C9488904CE4883F0FF48FFC1488904CE4883F0FF48FFC048FFC14839D172E25D5B5E5FC3" ; FillBuffer-ASM-Code als Binaercode
    $__g_bASMCode2 = "0x575653554889CE4889D248D1EA4C89C04831C9488B1CCE4839C3752B4883F0FF48FFC1488B1CCE4839C3751B4883F0FF48FFC048FFC14839D172D85D5B5E5F48C7C000000000C34889C85D5B5E5FC3" ; CheckBuffer-ASM-Code als Binaercode
Else ; 32 Bit Version
    $__g_bASMCode = '0x8B7424048B5424088B44240C31C989048E83F0FF4189048E83F0FF404139D172EDC3' ; FillBuffer-ASM-Code als Binaercode
    $__g_bASMCode2 = '0x8B7424048B5424088B44240C31C98B1C8E39C3751A83F0FF418B1C8E39C3750F83F0FF404139D172E5B800000000C389C8C3' ; CheckBuffer-ASM-Code als Binaercode
EndIf

#Region ASM-Binaercode in den Speicher schreiben
Global Const $__g_iMemSize = StringLen($__g_bASMCode) / 2 - 1 ; Codelaenge ermitteln
Global Const $__g_pMem = _MemVirtualAlloc(0, $__g_iMemSize, $MEM_COMMIT, $PAGE_EXECUTE_READWRITE) ; Virtuellen Speicher reservieren
If $__g_pMem = 0 Then Exit MsgBox(16, 'FillBuffer-Error!', "Can't allocate virtual memory!")
Global $__g_tASMCode = DllStructCreate('byte[' & $__g_iMemSize & ']', $__g_pMem) ; Structur fuer den Binaercode erstellen
DllStructSetData($__g_tASMCode, 1, $__g_bASMCode) ; den Binaercode in die Structur schreiben
Global $__g_pASMCode = DllStructGetPtr($__g_tASMCode) ; den Pointer der Structur holen

Global Const $__g_iMemSize2 = StringLen($__g_bASMCode2) / 2 - 1 ; Codelaenge ermitteln
Global Const $__g_pMem2 = _MemVirtualAlloc(0, $__g_iMemSize2, $MEM_COMMIT, $PAGE_EXECUTE_READWRITE) ; Virtuellen Speicher reservieren
If $__g_pMem2 = 0 Then Exit MsgBox(16, 'CheckBuffer-Error!', "Can't allocate virtual memory!")
Global $__g_tASMCode2 = DllStructCreate('byte[' & $__g_iMemSize2 & ']', $__g_pMem2) ; Structur fuer den Binaercode erstellen
DllStructSetData($__g_tASMCode2, 1, $__g_bASMCode2) ; den Binaercode in die Structur schreiben
Global $__g_pASMCode2 = DllStructGetPtr($__g_tASMCode2) ; den Pointer der Structur holen
#EndRegion ASM-Binaercode in den Speicher schreiben

#Region globale Variablen
Global $g_sFlashDrive, $g_sDisplay, $g_sWriteData, $g_sReadData, $g_bStop = False, $g_bStart = False, $g_bRun = False, $g_iBytesDiff, $g_bReadWrite = True
Global Const $__g_iIOBufferSize = 0x4000000 ; 64 MB I/O Buffer
Global Const $__g_pIOBuffer = _MemVirtualAlloc(0, $__g_iIOBufferSize, $MEM_COMMIT, $PAGE_READWRITE)
If $__g_pIOBuffer = 0 Then Exit MsgBox(16, 'IOBuffer-Error!', "Can't allocate virtual memory!")
Global $__g_tIOBuffer = DllStructCreate('dword[' & $__g_iIOBufferSize / 4 & ']', $__g_pIOBuffer)
#EndRegion globale Variablen

OnAutoItExitRegister('_OnExit')

While WinExists('FlashTest')
	Sleep(20)
	_CheckMailSlot(True)
WEnd
Exit

Func _OnExit()
	If $__g_pMem > 0 Then _MemVirtualFree($__g_pMem, $__g_iMemSize, $MEM_DECOMMIT)
	If $__g_pMem2 > 0 Then _MemVirtualFree($__g_pMem2, $__g_iMemSize, $MEM_DECOMMIT)
	If $__g_pIOBuffer > 0 Then _MemVirtualFree($__g_pIOBuffer, $__g_iIOBufferSize, $MEM_DECOMMIT)
EndFunc   ;==>_OnExit

Func _CheckMailSlot($bMain)
	Local $iSize, $sReadData
	$iSize = _MailSlotCheckForNextMessage($hMailSlot)
	If $iSize Then
		$sReadData = _MailSlotRead($hMailSlot, $iSize, 1)
		Switch StringLeft($sReadData, 2)
			Case 'R1'
				If $bMain Then _ReadFile(StringMid($sReadData, 3))
			Case 'W1'
				If $bMain Then _WriteFile(StringMid($sReadData, 3))
			Case 'CA'
				$g_bStop = True
		EndSwitch
	EndIf
EndFunc

Func _ReadFile($sTestFile)
	Local $iBufferSize, $hFile, $aRet, $nBytes, $iTicks, $iDiffAsm
	$iBufferSize = $__g_iIOBufferSize
	$hFile = _WinAPI_CreateFileEx($sTestFile, $OPEN_EXISTING, $GENERIC_READ, 0, $FILE_FLAG_NO_BUFFERING)
	If $hFile = 0 Then
		_MailSlotWrite($sMailSlotServer, 'E1', 1)
		Return
	Else
		For $i = 0 To (0x40000000 - $iBufferSize) / $iBufferSize ; 1024 MB (1 GB)
			If Not _WinAPI_ReadFile($hFile, $__g_pIOBuffer, $iBufferSize, $nBytes) Then ; ein Teil wird aus der Datei gelesen
				_MailSlotWrite($sMailSlotServer, 'E2' & Hex($iBufferSize * $i, 8), 1)
				_WinAPI_CloseHandle($hFile)
				Return
			EndIf
			$iTicks = _WinAPI_GetTickCount64()
			$aRet = DllCallAddress('UINT_PTR:cdecl', $__g_pASMCode2, 'UINT_PTR', $__g_pIOBuffer, 'UINT_PTR', $iBufferSize / 4, 'UINT_PTR', $iBufferSize * $i) ; ASM-Routine testet den Buffer
			$iDiffAsm = _WinAPI_GetTickCount64() - $iTicks
			If $aRet[0] Then ; die Rueckgabe der ASM-Routine enthaelt das fehlerhafte DWORD oder "0" fuer kein Fehler
				_MailSlotWrite($sMailSlotServer, 'E3' & Hex($iBufferSize * $i + $aRet[0] * 4, 8), 1)
			EndIf
			_MailSlotWrite($sMailSlotServer, 'RE' & $iDiffAsm & ',' & $nBytes, 1)
			_CheckMailSlot(False)
			If $g_bStop Then
				$g_bStop = False
				_WinAPI_CloseHandle($hFile)
				_MailSlotWrite($sMailSlotServer, 'CA', 1)
				Return
			EndIf
		Next
		_WinAPI_CloseHandle($hFile)
		_MailSlotWrite($sMailSlotServer, 'EN', 1)
	EndIf
EndFunc

Func _WriteFile($sTestFile)
	Local $iBufferSize, $hFile, $nBytes, $iTicks, $iDiffAsm
	$iBufferSize = $__g_iIOBufferSize
	$hFile = _WinAPI_CreateFileEx($sTestFile, $CREATE_ALWAYS, $GENERIC_WRITE, 0, $FILE_FLAG_NO_BUFFERING)
	If $hFile = 0 Then
		_MailSlotWrite($sMailSlotServer, 'E1', 1)
		Return
	Else
		For $i = 0 To Int((0x40000000 - $iBufferSize) / $iBufferSize) ; 1024 MB (1 GB)
			$iTicks = _WinAPI_GetTickCount64()
			DllCallAddress('uint_ptr:cdecl', $__g_pASMCode, 'uint_ptr', $__g_pIOBuffer, 'uint_ptr', $iBufferSize / 4, 'uint_ptr', $iBufferSize * $i) ; ASM-Routine fuellt den Buffer
			$iDiffAsm = _WinAPI_GetTickCount64() - $iTicks
			If Not _WinAPI_WriteFile($hFile, $__g_pIOBuffer, $iBufferSize, $nBytes) Then ; der Buffer wird in die Datei geschrieben
				_MailSlotWrite($sMailSlotServer, 'E2' & Hex($iBufferSize * $i, 8), 1)
				_WinAPI_CloseHandle($hFile)
				Return
			EndIf
			_MailSlotWrite($sMailSlotServer, 'RE' & $iDiffAsm & ',' & $nBytes, 1)
			_CheckMailSlot(False)
			If $g_bStop Then
				$g_bStop = False
				_WinAPI_CloseHandle($hFile)
				_MailSlotWrite($sMailSlotServer, 'CA', 1)
				Return
			EndIf
		Next
		_WinAPI_FlushFileBuffers($hFile)
		_WinAPI_CloseHandle($hFile)
		_MailSlotWrite($sMailSlotServer, 'EN', 1)
	EndIf
EndFunc

#Region ASM-Code
#Tidy_Off

; 32 Bit Version

#cs CheckBuffer
    Use32                                               ; 32Bit Modus!
    mov esi,[esp+4]                                     ; esi = Buffer (Pointer)
    mov edx,dword[esp+8]                                ; edx = Anzahl
    mov eax,dword[esp+12]                               ; eax = Startwert
    xor ecx,ecx                                         ; ecx = counter (auf 0 setzen)
    @loop:                                              ; Hauptschleife
        mov ebx,dword[esi+ecx*4]                        ; den Wert aus dem Buffer holen und in ebx speichern
        cmp ebx,eax                                     ; vergleichen, ob eax und ebx gleich sind
        jne @end                                        ; wenn Wert ungleich, dann Routine verlassen
        xor eax,0xffffffff                              ; eax invertieren
        inc ecx                                         ; counter++
        mov ebx,dword[esi+ecx*4]                        ; den Wert aus dem Buffer holen und in ebx speichern
        cmp ebx,eax                                     ; vergleichen, ob eax und ebx gleich sind
        jne @end                                        ; wenn Wert ungleich, dann Routine verlassen
        xor eax,0xffffffff                              ; eax wieder zurueck invertieren
        inc eax                                         ; eax++
        inc ecx                                         ; counter++
        cmp ecx,edx                                     ; Vergleich Counter mit Anzahl
        jb @loop                                        ; wenn kleiner, dann Schleife @loop weiter ausfuehren
        mov eax,0                                       ; kein Fehler, also 0 in eax laden (Rueckgabe an AutoIt)
        ret
    @end:
    mov eax,ecx                                         ; den Counter nach eax (Rueckgabe an AutoIt)
    ret
#ce

#cs FillBuffer
    Use32                                               ; 32Bit Modus!
    mov esi,[esp+4]                                     ; esi = Buffer (Pointer)
    mov edx,dword[esp+8]                                ; edx = Anzahl
    mov eax,dword[esp+12]                               ; eax = Startwert
    xor ecx,ecx                                         ; ecx = counter (auf 0 setzen)
    @loop:                                              ; Hauptschleife
        mov dword[esi+ecx*4],eax                        ; den Wert von eax in den Buffer schreiben
        xor eax,0xffffffff                              ; eax invertieren
        inc ecx                                         ; counter++
        mov dword[esi+ecx*4],eax                        ; den invertierten Wert von eax in den Buffer schreiben
        xor eax,0xffffffff                              ; eax wieder zurueck invertieren
        inc eax                                         ; eax++
        inc ecx                                         ; counter++
        cmp ecx,edx                                     ; Vergleich Counter mit Anzahl
        jb @loop                                        ; wenn kleiner, dann Schleife @loop weiter ausfuehren
    ret
#ce

; 64 Bit Version von: Andy (www.autoit.de)

#cs CheckBuffer64
    Use64                                                    ; 64Bit Modus!
    push rdi                                                 ;nichtflüchtige register retten
    push rsi
    push rbx
    push rbp
    ;bei fastCall werden die ersten 4 Parameter in Registern rcx, rdx, r8 und r9 übergeben...
    mov rsi,rcx                                              ;buffer
    mov rdx,rdx                                              ;Anzahl
    shr rdx,1                                                ;Anzahl/2 da 64 Bit (2*32)
    mov rax,r8                                               ;startwert
    xor rcx,rcx                                              ;counter
    @loop:                                                   ; Hauptschleife
    mov rbx,qword[rsi+rcx*8]                                 ; den Wert aus dem Buffer holen und in ebx speichern
    cmp rbx,rax                                              ; vergleichen, ob eax und ebx gleich sind
    jne @end                                                 ; wenn Wert ungleich, dann Routine verlassen
    xor rax,0xffffffffffffffff                               ; eax invertieren
    inc rcx                                                  ; counter++
    mov rbx,qword[rsi+rcx*8]                                 ; den Wert aus dem Buffer holen und in ebx speichern
    cmp rbx,rax                                              ; vergleichen, ob eax und ebx gleich sind
    jne @end                                                 ; wenn Wert ungleich, dann Routine verlassen
    xor rax,0xffffffffffffffff                               ; eax wieder zurueck invertieren
    inc rax                                                  ; eax++
    inc rcx                                                  ; counter++
    cmp rcx,rdx                                              ; Vergleich Counter mit Anzahl
    jb @loop                                                 ; wenn kleiner, dann Schleife @loop weiter ausfuehren
    pop rbp
    pop rbx
    pop rsi
    pop rdi
    mov rax,0                                                ; kein Fehler, also 0 in eax laden (Rueckgabe an AutoIt)
    ret
    @end:
    mov rax,rcx                                              ; den Counter nach eax (Rueckgabe an AutoIt)
    pop rbp
    pop rbx
    pop rsi
    pop rdi
    ret
#ce CheckBuffer64


#cs FillBuffer64
    Use64                                                    ; 64Bit Modus!
    push rdi                                                 ;nichtflüchtige register retten
    push rsi
    push rbx
    push rbp
    ;bei fastCall werden die ersten 4 Parameter in Registern rcx, rdx, r8 und r9 übergeben...
    mov rsi,rcx
    mov rdx,rdx
    shr rdx,1
    mov rax,r8
    xor rcx,rcx                                              ; ecx = counter (auf 0 setzen)
    @loop:                                                   ; Hauptschleife
    mov qword[rsi+rcx*8],rax                                 ; den Wert von eax in den Buffer schreiben
    xor rax,0xffffffffffffffff                               ; eax invertieren
    inc rcx                                                  ; counter++
    mov qword[rsi+rcx*8],rax                                 ; den invertierten Wert von eax in den Buffer schreiben
    xor rax,0xffffffffffffffff                               ; eax wieder zurueck invertieren
    inc rax                                                  ; eax++
    inc rcx                                                  ; counter++
    cmp rcx,rdx                                              ; Vergleich Counter mit Anzahl
    jb @loop                                                 ; wenn kleiner, dann Schleife @loop weiter ausfuehren
    pop rbp
    pop rbx
    pop rsi
    pop rdi
    ret
#ce FillBuffer64
#Tidy_On
#EndRegion ASM-Code