﻿#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=viewer.ico
#AutoIt3Wrapper_Outfile=FlashTest-Viewer.exe
#AutoIt3Wrapper_Outfile_x64=FlashTest-Viewer64.exe
#AutoIt3Wrapper_Compile_Both=y
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Description=FlashTest-Viewer
#AutoIt3Wrapper_Res_Fileversion=1.3.0.0
#AutoIt3Wrapper_Res_ProductName=FlashTest-Viewer
#AutoIt3Wrapper_Res_ProductVersion=1.3.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Gorathan (admin@technik-hobby.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#NoTrayIcon
#include <AutoItConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <FileConstants.au3>
#include <GDIPlus.au3>
#include <GDIPlusConstants.au3>
#include <GUIConstantsEx.au3>
#include <Math.au3>
#include <SendMessage.au3>
#include <StaticConstants.au3>
#include <StringConstants.au3>
#include <WinAPIConv.au3>
#include <WinAPIHObj.au3>
#include <WinAPIInternals.au3>
#include <WinAPISysInternals.au3>
#include <WindowsConstants.au3>

#Region *** Optionen ***
Opt('GUIOnEventMode', 1)
Opt('MustDeclareVars', 1)
Opt('GUICloseOnESC', 0)
#EndRegion *** Optionen ***

Global Const $sAppTitle = 'FlashTest-Viewer' & (@AutoItX64 ? '64' : '')
Global Const $sAppVersion = '1.3.0.0'
Global Const $sAppDate = '15.02.2020'
Global Const $sAppAuthor = 'Gorathan / Oscar'
Global Const $sAppAuthorEMail = 'mailto:admin@technik-hobby.de'
Global Const $sAppURL = 'https://forum.technik-hobby.de'
Global Const $sLicence = 'Das Programm steht unter der "CC BY-NC-ND 4.0" Lizenz\n- freie Weitergabe mit Namensnennung\n- nicht kommerziell\n- keine Bearbeitung'
Global Const $sAppIcon = @Compiled ? @AutoItExe : @ScriptDir & '\prog.ico'
Global Const $iAppDPI = RegRead('HKEY_CURRENT_USER\Control Panel\Desktop\WindowMetrics', 'AppliedDPI')

_GDIPlus_Startup()
Global $g_sFilename, $g_sResultData, $g_sHeader, $g_sResultFile, $g_sWriteData, $g_sReadData, $g_sHeader, $g_sResultData
Global $g_iPenSize = 2

Global $hMainGui = GUICreate(StringFormat('%s - v%3.3s - © 2020 by Gorathan (admin@technik-hobby.de)', $sAppTitle, $sAppVersion), 1020, 660)
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseMainGui')
GUISetBkColor(0xCCCCCC)
GUISetFont(12 / $iAppDPI * 96, 400, 0, 'Verdana')
GUISetIcon($sAppIcon)

GUICtrlCreateGroup('FlashTest-Datei auswählen', 20, 5, 985, 55)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
Global $idFtPath = GUICtrlCreateLabel($g_sFilename, 30, 27, 910, 24)
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 400, 0, 'Verdana')
GUICtrlSetBkColor(-1, 0xEEEEEE)
Global $idFtPathSelect = GUICtrlCreateButton('...', 945, 24, 50, 28)
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 400, 0, 'Verdana')
GUICtrlSetOnEvent(-1, '_SelectPath')
GUICtrlCreateGroup('', -99, -99, 1, 1)

Global $idPic = GUICtrlCreatePic('', 20, 70, 600, 300) ; FlashTest-Grafik
_CtrlSetImage($idPic, $g_iPenSize)

GUICtrlCreateLabel('', 20, 380, 600, 270, $SS_BLACKRECT)
Global $idResult = GUICtrlCreateLabel($g_sResultData, 23, 383, 594, 264) ; FlashTest-Text
GUICtrlSetBkColor(-1, 0xFFFFFF)

GUICtrlCreateGroup('Grafikformat (PNG-Datei)', 635, 70, 370, 295)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
GUICtrlCreateLabel('Auflösung auswählen:', 655, 100, 250, 20)
Global $idResolution1 = GUICtrlCreateRadio('aus Vorgaben:', 655, 125, 160, 30)
GUICtrlSetState(-1, $GUI_CHECKED)
Global $idResolutionSelect = GUICtrlCreateCombo('', 815, 125, 170, 30, $CBS_DROPDOWNLIST)
GUICtrlSetData(-1, '2400 x 1200|1800 x  900|1600 x  800|1200 x  600| 800 x  400| 600 x  300', ' 800 x  400')
GUICtrlSetFont(-1, 16 / $iAppDPI * 96, 800, 0, 'Courier New')
GUICtrlSetOnEvent(-1, '_SelectResolution')
Global $idResolution2 = GUICtrlCreateRadio('per Eingabe:', 655, 160, 160, 30)
Global $idResolutionInput = GUICtrlCreateInput('', 815, 162, 170, 26)
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 600, 0, 'Courier New')
GUICtrlCreateLabel('Strichstärke auswählen:', 655, 215, 270, 20)
Global $idSizeSelect = GUICtrlCreateCombo('', 925, 210, 60, 30, $CBS_DROPDOWNLIST)
GUICtrlSetData(-1, '1|2|3|4|5|6', '2')
GUICtrlSetFont(-1, 16 / $iAppDPI * 96, 800, 0, 'Courier New')
Global $idCreateGfx = GUICtrlCreateButton('Grafik erstellen', 660, 320, 160, 30)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_CreateGraphic')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Textformat (UTF-8 mit BOM)', 635, 380, 370, 265)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
GUICtrlCreateLabel('Format auswählen:', 655, 410, 250, 20)
Global $aidText[3]
$aidText[0] = GUICtrlCreateRadio('Text-Datei (nur Text)', 655, 435, 320, 30)
$aidText[1] = GUICtrlCreateRadio('HTML-Datei (nur Text)', 655, 470, 320, 30)
$aidText[2] = GUICtrlCreateRadio('HTML-Datei (Text + Grafik)', 655, 505, 320, 30)
GUICtrlSetState(-1, $GUI_CHECKED)
Global $idCreatTxt = GUICtrlCreateButton('Text erstellen', 660, 600, 160, 30)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_CreateText')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUISetState(@SW_SHOW, $hMainGui)
GUIRegisterMsg($WM_COMMAND, '_WM_COMMAND')
WinWaitClose($hMainGui)

Func _CloseMainGui()
	GUIDelete($hMainGui)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>_CloseMainGui

Func _WM_COMMAND($hWnd, $Msg, $wParam, $lParam)
	#forceref $hWnd, $Msg, $lParam
	Local $iIDFrom, $iCode
	$iIDFrom = _WinAPI_LoWord($wParam)
	$iCode = _WinAPI_HiWord($wParam)
	Switch $iIDFrom
		Case $idResolutionInput
			Switch $iCode
				Case $EN_SETFOCUS
					GUICtrlSetState($idResolution1, $GUI_UNCHECKED)
					GUICtrlSetState($idResolution2, $GUI_CHECKED)
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_COMMAND

Func _SelectResolution()
	GUICtrlSetState($idResolution1, $GUI_CHECKED)
	GUICtrlSetState($idResolution2, $GUI_UNCHECKED)
EndFunc   ;==>_SelectResolution

Func _CreateGraphic()
	Local $iW, $iH, $sRes, $iPenSize
	If BitAND(GUICtrlRead($idResolution1), $GUI_CHECKED) Then
		$sRes = GUICtrlRead($idResolutionSelect)
	Else
		$sRes = GUICtrlRead($idResolutionInput)
	EndIf
	$g_sResultFile = StringRegExpReplace($g_sFilename, '.+\\(.+\.).+', '$1') ; nur der Dateiname (ohne Pfad und ohne Endung)
	$iW = StringRegExpReplace($sRes, '.*?(\d+).*x.*', '$1')
	$iH = StringRegExpReplace($sRes, '.*x.*?(\d+).*', '$1')
	$iPenSize = Number(GUICtrlRead($idSizeSelect))
	_SaveImage($g_sResultFile & 'png', $iW, $iH, $iPenSize)
	MsgBox(0, $sAppTitle, 'Grafikdatei erstellt!')
EndFunc   ;==>_CreateGraphic

Func _CreateText()
	Local $iSelect, $hFile
	For $iSelect = 0 To UBound($aidText) - 1
		If BitAND(GUICtrlRead($aidText[$iSelect]), $GUI_CHECKED) Then ExitLoop
	Next
	$g_sResultFile = StringRegExpReplace($g_sFilename, '.+\\(.+\.).+', '$1') ; nur der Dateiname (ohne Pfad und ohne Endung)
	Switch $iSelect
		Case 0
			_WriteText($g_sResultFile & 'txt', $g_sHeader, $g_sResultData)
		Case 1
			_WriteHTML($g_sResultFile & 'html', $g_sHeader, $g_sResultData)
		Case 2
			_CreateGraphic()
			_WriteHTML($g_sResultFile & 'html', $g_sHeader, $g_sResultData, $g_sResultFile & 'png')
	EndSwitch
	MsgBox(0, $sAppTitle, 'Textdatei erstellt!')
EndFunc   ;==>_CreateText

Func _SelectPath()
	Local $sPath
	$sPath = FileOpenDialog($sAppTitle, @ScriptDir & '\results\', 'FlashTest-Dateien (*.ftr)', $FD_FILEMUSTEXIST, '', $hMainGui)
	If @error Then Return
	GUICtrlSetData($idFtPath, $sPath)
	$g_sFilename = $sPath
	$g_sResultData = FileRead($g_sFilename)
	$g_sWriteData = StringRegExpReplace($g_sResultData, '(?s).+Schreibtest\:\r\n(.+?)\r\n.+', '$1') ; die Schreibdaten extrahieren
	$g_sReadData = StringRegExpReplace($g_sResultData, '(?s).+Lesetest\:\r\n(.+?)\r\n.*', '$1') ; die Lesedaten extrahieren
	$g_sHeader = StringRegExpReplace($g_sResultData, '(?s)(.+?)\r\n.+', '$1') ; die erste Zeile als Ueberschrift
	$g_sResultData = StringRegExpReplace($g_sResultData, '(?s).+?\r\n(.+\r\nTest beendet\.).+', '$1') ; den restlichen Text als Body
	GUICtrlSetData($idResult, $g_sResultData)
	_CtrlSetImage($idPic, $g_iPenSize)
	GUICtrlSetState($idCreateGfx, $GUI_ENABLE)
	GUICtrlSetState($idCreatTxt, $GUI_ENABLE)
EndFunc   ;==>_SelectPath
	FileChangeDir(@ScriptDir)
Func _WriteText($sFilename, $sHeader, $sBody)
	Local $hFile
	FileChangeDir(@ScriptDir & '\results\')
	$hFile = FileOpen($sFilename, BitOR($FO_CREATEPATH, $FO_OVERWRITE, $FO_UTF8))
	If $hFile <> -1 Then
		FileWriteLine($hFile, $sHeader)
		FileWriteLine($hFile, $sBody)
		FileClose($hFile)
	EndIf
EndFunc   ;==>_WriteText

Func _WriteHTML($sFilename, $sHeader, $sBody, $sImgSrc = '')
	Local Const $sStartHtml = '<!DOCTYPE html>\r\n<html lang="de">\r\n\t<head>\r\n\t\t<meta charset="utf-8" />\r\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1.0" />\r\n\t\t<title>%s</title>\r\n\t\t<style type="text/css">\r\n\t\t\tbody {margin: 20px;}\r\n\t\t\tp {font-size: 18px;}\r\n\t\t\th1 {font-size: 22px;}\r\n\t\t</style>\r\n\t</head>\r\n\t<body>\r\n\t\t<h1>%s</h1>\r\n\t\t<p>%s</p>\r\n'
	Local Const $sImgHtml = '\t\t<img src="%s">\r\n'
	Local Const $sEndHtml = '\t</body>\r\n</html>\r\n'
	Local $sTitle = 'FlashTest-Auswertung', $sHTML, $hFile
	$sBody = StringReplace($sBody, @CRLF, '<br>')
	If $sImgSrc <> '' Then
		$sHTML = StringFormat($sStartHtml & $sImgHtml & $sEndHtml, $sTitle, $sHeader, $sBody, $sImgSrc)
	Else
		$sHTML = StringFormat($sStartHtml & $sEndHtml, $sTitle, $sHeader, $sBody)
	EndIf
	FileChangeDir(@ScriptDir & '\results\')
	$hFile = FileOpen($sFilename, BitOR($FO_CREATEPATH, $FO_OVERWRITE, $FO_UTF8))
	If $hFile <> -1 Then
		FileWrite($hFile, $sHTML)
		FileClose($hFile)
	EndIf
EndFunc   ;==>_WriteHTML

Func _SaveImage($sFilename, $iW, $iH, $iPenSize)
	Local $hBitmap
	$hBitmap = _CreateImage($iW, $iH, $iPenSize)
	FileChangeDir(@ScriptDir & '\results\')
	_GDIPlus_ImageSaveToFile($hBitmap, $sFilename)
	_GDIPlus_BitmapDispose($hBitmap)
EndFunc   ;==>_SaveImage

Func _CtrlSetImage($idCtrl, $iPenSize)
	Local $iW, $hBitmap, $iH, $hBMP, $hPrevImage
	$iW = _WinAPI_GetWindowWidth(GUICtrlGetHandle($idCtrl))
	$iH = _WinAPI_GetWindowHeight(GUICtrlGetHandle($idCtrl))
	$hBitmap = _CreateImage($iW, $iH, $iPenSize)
	$hBMP = _GDIPlus_BitmapCreateDIBFromBitmap($hBitmap)
	$hPrevImage = _SendMessage(GUICtrlGetHandle($idCtrl), $STM_SETIMAGE, $IMAGE_BITMAP, $hBMP)
	If $hPrevImage Then _WinAPI_DeleteObject($hPrevImage)
	_GDIPlus_BitmapDispose($hBitmap)
EndFunc   ;==>_CtrlSetImage

Func _CreateImage($iW, $iH, $iPenSize = 2)
	Local $aWriteData, $aReadData, $aWMinMax, $aRMinMax, $iMax, $iYStep, $iXStep, $aPoints, $iGB = 0, $iScale
	Local $hBitmap, $hGraphic, $hPen, $hPenW, $hPenR, $hBrush, $hFamily, $hFont, $hLayout, $hFormat
	$hBitmap = _GDIPlus_BitmapCreateFromScan0($iW, $iH)
	$hGraphic = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hGraphic, 2)
	_GDIPlus_GraphicsSetInterpolationMode($hGraphic, 7)
	_GDIPlus_GraphicsClear($hGraphic, 0xFFFFFFFF)
	$hPen = _GDIPlus_PenCreate(0xFF000000, 2) ; Pen fuer die Gitterlinien
	_GDIPlus_GraphicsDrawRect($hGraphic, 1, 1, $iW - 3, $iH - 3, $hPen)
	If $g_sFilename = '' Then
		_GDIPlus_PenDispose($hPen)
		_GDIPlus_GraphicsDispose($hGraphic)
		Return $hBitmap
	EndIf
	$aWriteData = StringSplit(StringTrimRight($g_sWriteData, 1), '|', $STR_NOCOUNT)
	$aReadData = StringSplit(StringTrimRight($g_sReadData, 1), '|', $STR_NOCOUNT)
	$aWMinMax = _CalcMinMax($aWriteData)
	$aRMinMax = _CalcMinMax($aReadData)
	$iMax = (Int(_Max($aRMinMax[1], $aWMinMax[1]) / 50) + 1) * 50
	$iYStep = Int($iMax / 10)
	$iXStep = Round(($iW - 83) / _Max(UBound($aWriteData), UBound($aReadData)), 4)
	_GDIPlus_PenSetColor($hPen, 0xFFDDDDDD)
	_GDIPlus_PenSetDashStyle($hPen, $GDIP_DASHSTYLEDASH)
	$hPenW = _GDIPlus_PenCreate(0xFFFF6622, $iPenSize) ; Pen fuer die Schreibdaten
	$hPenR = _GDIPlus_PenCreate(0xFF2266FF, $iPenSize) ; Pen fuer die Lesedaten
	$iH -= 30 ; 30 Pixel am unteren Bildrand fuer die Beschriftung freilassen
	$hBrush = _GDIPlus_BrushCreateSolid(0xFF000000)
	$hFamily = _GDIPlus_FontFamilyCreate('Verdana')
	$hFont = _GDIPlus_FontCreate($hFamily, 9)
	$hFormat = _GDIPlus_StringFormatCreate()
	$iScale = ($iXStep < 3 ? 2 : 1) * ($iXStep < 1.5 ? 2 : 1) * ($iXStep < 0.75 ? 2 : 1) ; zum skalieren der X-Achsen-Beschriftung
	_GDIPlus_StringFormatSetAlign($hFormat, 1) ; Textausrichtung zentriert
	For $i = 80 To $iW Step $iXStep * 16 * $iScale ; Beschriftung unten (X-Achse)
		If $i < $iW - 3 - $iXStep Then
			$hLayout = _GDIPlus_RectFCreate($i - 18, $iH + 6, 48, 18)
			_GDIPlus_GraphicsDrawStringEx($hGraphic, $iGB * $iScale & ' GB', $hFont, $hLayout, $hFormat, $hBrush)
			_GDIPlus_GraphicsDrawLine($hGraphic, $i, 3, $i, $iH, $hPen) ; vertikale Linien
		EndIf
		$iGB += 1
	Next
	_GDIPlus_StringFormatSetAlign($hFormat, 2) ; Textausrichtung rechts
	For $i = 1 To 10 ; Beschriftung links (Y-Achse)
		$hLayout = _GDIPlus_RectFCreate(0, Int($iH / 10 * $i) - 10, 75, Int($iH / 10 * $i) + 9)
		_GDIPlus_GraphicsDrawStringEx($hGraphic, $iMax - $iYStep * $i & ' MB/s', $hFont, $hLayout, $hFormat, $hBrush)
		_GDIPlus_GraphicsDrawLine($hGraphic, 80, Int($iH / 10 * $i) - 1, $iW - 3, Int($iH / 10 * $i) - 1, $hPen) ; horizontale Linien
	Next
	$aPoints = _CreateCurvePointArray($aWriteData, $iMax, $iXStep, $iH) ; Schreibdaten in Kurvendaten-Array umwandeln
	_GDIPlus_GraphicsDrawCurve($hGraphic, $aPoints, $hPenW)
	$aPoints = _CreateCurvePointArray($aReadData, $iMax, $iXStep, $iH) ; Lesedaten in Kurvendaten-Array umwandeln
	_GDIPlus_GraphicsDrawCurve($hGraphic, $aPoints, $hPenR)
	_GDIPlus_BrushDispose($hBrush)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_PenDispose($hPenR)
	_GDIPlus_PenDispose($hPenW)
	_GDIPlus_PenDispose($hPen)
	_GDIPlus_GraphicsDispose($hGraphic)
	Return $hBitmap
EndFunc   ;==>_CreateImage

Func _CreateCurvePointArray(ByRef $aData, $iMax, $iX, $iH)
	Local $iCount = UBound($aData), $aPoints[$iCount + 1][2] = [[$iCount, 0]]
	For $i = 0 To $iCount - 1
		$aPoints[$i + 1][0] = 80 + $i * $iX
		$aPoints[$i + 1][1] = Int($iH - $iH / $iMax * Number($aData[$i], $NUMBER_DOUBLE))
	Next
	Return $aPoints
EndFunc   ;==>_CreateCurvePointArray

Func _CalcMinMax(ByRef $aData)
	Local $aMinMax[2] = [99999.9, 0.0] ; $aData enthaelt Fliesskommazahlen
	For $sData In $aData
		If Number($sData, $NUMBER_DOUBLE) < Number($aMinMax[0], $NUMBER_DOUBLE) Then $aMinMax[0] = Number($sData, $NUMBER_DOUBLE) ; Minimalwert ermitteln
		If Number($sData, $NUMBER_DOUBLE) > Number($aMinMax[1], $NUMBER_DOUBLE) Then $aMinMax[1] = Number($sData, $NUMBER_DOUBLE) ; Maximalwert ermitteln
	Next
	Return $aMinMax
EndFunc   ;==>_CalcMinMax
