﻿#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=prog.ico
#AutoIt3Wrapper_Outfile=FlashTest.exe
#AutoIt3Wrapper_Outfile_x64=FlashTest64.exe
#AutoIt3Wrapper_Compile_Both=y
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Description=FlashTest
#AutoIt3Wrapper_Res_Fileversion=1.5.0.0
#AutoIt3Wrapper_Res_ProductName=FlashTest
#AutoIt3Wrapper_Res_ProductVersion=1.5.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Gorathan (admin@technik-hobby.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#NoTrayIcon
#include <APIFilesConstants.au3>
#include <APIProcConstants.au3>
#include <Array.au3>
#include <AutoItConstants.au3>
#include <ComboConstants.au3>
#include <Date.au3>
#include <Debug.au3>
#include <EditConstants.au3>
#include <File.au3>
#include <FileConstants.au3>
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GuiEdit.au3>
#include <Misc.au3>
#include <ProgressConstants.au3>
#include <SendMessage.au3>
#include <StaticConstants.au3>
#include <StringConstants.au3>
#include <Timers.au3>
#include <WinAPIConv.au3>
#include <WinAPIFiles.au3>
#include <WinAPIHObj.au3>
#include <WinAPIInternals.au3>
#include <WinAPIMem.au3>
#include <WinAPIProc.au3>
#include <WinAPISys.au3>
#include <WinAPISysInternals.au3>
#include <WindowsConstants.au3>

#include 'includes\MailSlot.au3'
#include 'includes\WinAPI_ThemeSetProgress.au3'

#Region *** Optionen ***
Opt('GUIOnEventMode', 1)
Opt('MustDeclareVars', 1)
Opt('GUICloseOnESC', 0)
#EndRegion *** Optionen ***

_WinAPI_SetPriorityClass($HIGH_PRIORITY_CLASS)
_GDIPlus_Startup()
OnAutoItExitRegister('_OnExit')

#Region *** Konstanten deklarieren ***
Global Const $DBT_DEVICEARRIVAL = 0x8000 ; A device or piece of media has been inserted and is now available.
Global Const $DBT_DEVICEREMOVECOMPLETE = 0x8004 ; A device or piece of media has been removed.
Global Const $tagDEV_BROADCAST_HDR = 'dword dbch_size; dword dbch_devicetype; dword dbch_reserved'
Global Const $tagDEV_BROADCAST_VOLUME = 'dword dbcv_size; dword dbcv_devicetype; dword dbcv_reserved; dword dbcv_unitmask; dword dbcv_flags'
Global Const $DBT_DEVTYP_VOLUME = 0x00000002
Global Const $sAppTitle = 'FlashTest' & (@AutoItX64 ? '64' : '')
Global Const $sAppVersion = '1.5.0.0'
Global Const $sAppDate = '15.02.2020'
Global Const $sAppAuthor = 'Gorathan / Oscar'
Global Const $sAppAuthorEMail = 'mailto:admin@technik-hobby.de'
Global Const $sAppURL = 'https://forum.technik-hobby.de'
Global Const $sLicence = 'Das Programm steht unter der "CC BY-NC-ND 4.0" Lizenz\n- freie Weitergabe mit Namensnennung\n- nicht kommerziell\n- keine Bearbeitung'
Global Const $sAppIcon = @Compiled ? @AutoItExe : @ScriptDir & '\prog.ico'
Global Const $iAppDPI = RegRead('HKEY_CURRENT_USER\Control Panel\Desktop\WindowMetrics', 'AppliedDPI')
Global Const $sMailSlotServer = '\\.\mailslot\FlashTestServer'
Global Const $sMailSlotSlave = '\\.\mailslot\FlashTestSlave'
#EndRegion *** Konstanten deklarieren ***
_Singleton($sAppTitle)

#Region globale Variablen
Global $hMailSlot = _MailSlotCreate($sMailSlotServer)
If @error Then Exit MsgBox(48 + 262144, 'MailSlotServer', 'Failed to create new account!' & @CRLF & 'Probably one using that "address" already exists.')
Global $g_sFlashDrive, $g_sDisplay, $g_sWriteData, $g_sReadData, $g_bStop = False, $g_bStart = False, $g_bRun = False, $g_iBytesDiff, $g_bReadWrite = True
Global $g_iSlavePID = 0
#EndRegion globale Variablen

#Region *** Hauptfenster erstellen ***
Global $hMainGui = GUICreate(StringFormat('%s - v%3.3s - © 2020 by Gorathan (admin@technik-hobby.de)', $sAppTitle, $sAppVersion), 1020, 560)
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseMainGui')
GUISetBkColor(0xD0D0D0)
GUISetFont(11 / $iAppDPI * 96, 400, 0, 'Verdana')
GUISetIcon($sAppIcon)

GUICtrlCreateGroup('Test-Laufwerk auswählen', 5, 10, 260, 70)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
Global $idFlashDrive = GUICtrlCreateCombo('', 25, 35, 220, 20, $CBS_DROPDOWNLIST)
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 400, 0, 'Courier New')
GUICtrlSetData(-1, _ReadFlashDrives())
GUICtrlSetOnEvent(-1, '_SwitchDrive')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Speicherplatz für Schreibtest', 5, 90, 260, 90)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
Global $idTestSpaceAll = GUICtrlCreateRadio('gesamter freier Speicher', 25, 115, 200, 20)
GUICtrlSetState(-1, $GUI_CHECKED)
Global $idTestSpaceSel = GUICtrlCreateRadio('nur', 25, 145, 45, 20)
GUICtrlSetOnEvent(-1, '_SelectSpace')
Global $idTestSpaceInp = GUICtrlCreateInput('', 80, 143, 80, 22, BitOR($ES_NUMBER, $ES_RIGHT))
Global $idTestSpaceLabel = GUICtrlCreateLabel('GB', 165, 145, 50, 20)
GUICtrlCreateGroup('', -99, -99, 1, 1)
_CtrlSetState($idTestSpaceAll, $idTestSpaceLabel, $GUI_DISABLE)

GUICtrlCreateGroup('Laufwerksinformationen', 280, 10, 460, 180)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
GUICtrlCreateLabel('Bezeichnung:', 300, 35, 120, 20)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
Global $idDriveLabel = GUICtrlCreateLabel('', 420, 35, 280, 20)
GUICtrlCreateLabel('Typ:', 300, 60, 120, 20)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
Global $idDriveTyp = GUICtrlCreateLabel('', 420, 60, 280, 20)
GUICtrlCreateLabel('Anschluß:', 300, 85, 120, 20)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
Global $idBusTyp = GUICtrlCreateLabel('', 420, 85, 280, 20)
GUICtrlCreateLabel('Modell:', 300, 110, 120, 20)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
Global $idModel = GUICtrlCreateLabel('', 420, 110, 280, 20)
GUICtrlCreateLabel('Dateisystem:', 300, 135, 120, 20)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
Global $idFileSystem = GUICtrlCreateLabel('', 420, 135, 280, 20)
GUICtrlCreateLabel('Speicherplatz:', 300, 160, 120, 20)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
Global $idDriveSpace = GUICtrlCreateLabel('', 420, 160, 280, 20)
GUICtrlCreateGroup('', -99, -99, 1, 1)

Global $idProgressGroup = GUICtrlCreateGroup('Fortschritt', 5, 190, 260, 50)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
Global $idProgress = GUICtrlCreateLabel('', 15, 212, 90, 20, $SS_RIGHT)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idProgressAll = GUICtrlCreateLabel('', 110, 212, 120, 20)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 0, 'Verdana')
GUICtrlCreateGroup('', -99, -99, 1, 1)

Global $idTestStartRW = GUICtrlCreateButton('Schreib-/Lesetest', 280, 200, 220, 26)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_StartTest')
Global $idTestStartR = GUICtrlCreateButton('Nur Lesetest', 280, 227, 220, 26)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_StartTest')
Global $idTestCancel = GUICtrlCreateButton('abbrechen', 510, 200, 100, 53)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_StopTest')
Global $idStartViewer = GUICtrlCreateButton('Viewer' & @CRLF & 'starten', 620, 200, 110, 53, 0x2000)
GUICtrlSetOnEvent(-1, '_StartViewer')

Global $idTestProgress = GUICtrlCreateGroup('Testverlauf (schreiben)', 5, 250, 735, 245)
GUICtrlSetFont(-1, 10)
Global $idStartTime = GUICtrlCreateLabel('Start:', 140, 270, 140, 20)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idEndTime = GUICtrlCreateLabel('Ende:', 437, 270, 140, 20, $SS_RIGHT)
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idTestDisplay = GUICtrlCreatePic('', 100, 290, 512, 160)
Global $aidTestLabel[7]
For $i = 0 To UBound($aidTestLabel) - 1
	$aidTestLabel[$i] = GUICtrlCreateLabel('0 MB/s', 15, 440 - $i * 26, 70, 16, $SS_RIGHT)
	GUICtrlSetFont(-1, 9 / $iAppDPI * 96, 400, 0, 'Verdana')
Next
Global $aidTestTime[11]
For $i = 0 To 8
	$aidTestTime[$i] = GUICtrlCreateLabel($i * 2, 85 + $i * 64, 460, 32, 16, $SS_CENTER)
	GUICtrlSetFont(-1, 9 / $iAppDPI * 96, 400, 0, 'Verdana')
Next
For $i = 0 To 512 Step 8
	GUICtrlCreateLabel('', 100 + $i, 450, 1, 5 + (Mod($i, 16) ? 0 : 5), $SS_BLACKFRAME)
Next
GUICtrlCreateLabel('Speicherplatz (in GigaByte)', 280, 474, 200, 16)
GUICtrlSetFont(-1, 9 / $iAppDPI * 96, 400, 0, 'Verdana')

Global $idSpeedMax = GUICtrlCreateLabel('< 0.0 MB/s', 625, 296, 100, 20)
GUICtrlSetFont(-1, 9 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idSpeedAvg = GUICtrlCreateLabel('Ø 0.0 MB/s', 625, 360, 100, 20)
GUICtrlSetFont(-1, 9 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idSpeedMin = GUICtrlCreateLabel('> 0.0 MB/s', 625, 426, 100, 20)
GUICtrlSetFont(-1, 9 / $iAppDPI * 96, 400, 0, 'Verdana')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Testbericht', 750, 10, 265, 485)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
Global $idConsole = GUICtrlCreateEdit('', 760, 30, 245, 455, BitOR($ES_READONLY, $ES_WANTRETURN, $WS_VSCROLL, $ES_AUTOVSCROLL))
GUICtrlSetFont(-1, 9 / $iAppDPI * 96, 400, 0, 'Verdana')
GUICtrlSetBkColor(-1, 0xFFFFFF)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('CPU-Auslastung', 5, 500, 735, 55)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
Global $idCPUCycle = GUICtrlCreatePic('', 15, 520, 710, 28)
_WinAPI_ThemeSetProgress(-1, 0, $PBST_PERCENT, 14, 'Verdana')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('RAM-Belegung', 750, 500, 265, 55)
GUICtrlSetFont(-1, 10 / $iAppDPI * 96)
Global $idRAMfreeLabel = GUICtrlCreateLabel('', 760, 525, 240, 20, $SS_CENTER)
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
GUICtrlSetColor(-1, 0x000000)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlCreateGroup('', -99, -99, 1, 1)
#EndRegion *** Hauptfenster erstellen ***

GUIRegisterMsg($WM_COMMAND, '_WM_COMMAND')
GUIRegisterMsg($WM_DEVICECHANGE, '_WM_DEVICECHANGE')
GUIRegisterMsg($WM_NCLBUTTONDOWN, '_WM_NCLBUTTONDOWN')
HotKeySet('{ESC}', '_StopTest')
_Timer_SetTimer($hMainGui, 500, '_CPUCycleTime')
_DrawPath($idTestDisplay, '')
GUISetState(@SW_SHOW, $hMainGui)

While Sleep(50)
	If $g_bStart Then _RunTest()
WEnd

Func _OnExit()
	_Timer_KillAllTimers($hMainGui)
	_GDIPlus_Shutdown()
EndFunc   ;==>_OnExit

Func _CloseMainGui()
	If ProcessExists($g_iSlavePID) Then ProcessClose($g_iSlavePID)
	GUIDelete($hMainGui)
	Exit
EndFunc   ;==>_CloseMainGui

Func _CPUCycleTime($hWnd, $iMsg, $iIDTimer, $iTime)
	#forceref $hWnd, $iMsg, $iIDTimer, $iTime
	Local Static $iOldTime = 0, $aOldData[13]
	Local $iPercent = _GetCPUUsage()
	If Not @error And $iPercent >= 0 And $iPercent <= 100 Then
		_WinAPI_ThemeSetProgress(GUICtrlGetHandle($idCPUCycle), $iPercent, $PBST_PERCENT, 14, 'Verdana')
	EndIf
	Local $aData = _WinAPI_GetPerformanceInfo()
	If @error Then Return
	$aData[4] = Int($aData[4] / 1048576) * 1048576
	If $aOldData[4] <> $aData[4] And $iTime - $iOldTime > 1000 Then
		$iOldTime = $iTime
		$aOldData = $aData
		$aData[3] = Int($aData[3] / 1048576) * 1048576
		GUICtrlSetData($idRAMfreeLabel, _WinAPI_StrFormatByteSize($aData[3] - $aData[4]) & ' / ' & _WinAPI_StrFormatByteSize($aData[3]))
	EndIf
EndFunc   ;==>_CPUCycleTime

Func _GetCPUUsage()
	Local Static $aOld[3], $iTicksOld, $aSystemInfo, $aBuf[] = [0, 0, 0], $iCount = 0
	Local $aRet, $iTime1, $iTime2, $iPercent, $iTicks
	$iTicks = _WinAPI_GetTickCount64()
	$aRet = _WinAPI_GetSystemTimes()
	If @error Then Return SetError(@error, @extended, 0)
	If $aOld[0] = 0 Then ; beim ersten Aufruf die Static-Variablen fuellen
		$aSystemInfo = _WinAPI_GetSystemInfo() ; $aSystemInfo[5] = Number of physical processors
		If @error Then Return SetError(@error, @extended, 0)
		$iTicksOld = $iTicks
		$aOld = $aRet
		Return 0
	EndIf
	$iTime1 = $aRet[1] - $aRet[0] + $aRet[2] ; [0] = idle-time, [1] = kernel-time, [2] = user-time
	$iTime2 = $aOld[1] - $aOld[0] + $aOld[2] ; [0] = idle-time, [1] = kernel-time, [2] = user-time
	$iPercent = Int(($iTime1 - $iTime2) / (($iTicks - $iTicksOld) * 100) / $aSystemInfo[5])
	$aBuf[$iCount] = $iPercent ; Messung in den Ringbuffer
	$iCount += 1
	If $iCount > UBound($aBuf) - 1 Then $iCount = 0
	$iPercent = Ceiling(($aBuf[0] + $aBuf[1] + $aBuf[2]) / 3) ; Mittelwert von 3 Messungen bilden
	$iTicksOld = $iTicks
	$aOld = $aRet
	Return $iPercent
EndFunc   ;==>_GetCPUUsage

Func _SelectSpace()
	GUICtrlSetState($idTestSpaceInp, $GUI_FOCUS)
EndFunc   ;==>_SelectSpace

Func _CtrlSetState($iStart, $iEnd, $iState)
	For $iCtrl = $iStart To $iEnd
		GUICtrlSetState($iCtrl, $iState)
	Next
EndFunc   ;==>_CtrlSetState

Func _StopTest()
	GUICtrlSetState($idTestCancel, $GUI_DISABLE)
	$g_bStop = True
	_MailSlotWrite($sMailSlotSlave, 'CA', 1)
EndFunc   ;==>_StopTest

Func _StartTest()
	$g_bReadWrite = (@GUI_CtrlId == $idTestStartRW)
	$g_bStart = True
EndFunc   ;==>_StartTest

Func _StartViewer()
	ShellExecute(@ScriptDir & '\FlashTest-Viewer' & (@AutoItX64 ? '64' : '') & '.exe')
EndFunc   ;==>_StartViewer

Func _ConsoleWrite($sMsg)
	_GUICtrlEdit_AppendText($idConsole, $sMsg)
EndFunc   ;==>_ConsoleWrite

Func _SaveTestData()
	Local $hFile, $sFilename
	$sFilename = StringFormat('%s\\results\\%04i_%02i_%02i__%02i_%02i_%02i.ftr', @ScriptDir, @YEAR, @MON, @MDAY, @HOUR, @MIN, @SEC)
	$hFile = FileOpen($sFilename, BitOR($FO_UTF8, $FO_CREATEPATH, $FO_OVERWRITE))
	If $hFile = -1 Then Return
	FileWrite($hFile, GUICtrlRead($idConsole))
	FileWriteLine($hFile, 'Daten vom Schreibtest:')
	FileWriteLine($hFile, $g_sWriteData)
	FileWriteLine($hFile, 'Daten vom Lesetest:')
	FileWriteLine($hFile, $g_sReadData)
	FileClose($hFile)
EndFunc   ;==>_SaveTestData

Func _CheckIfSlaveExist()
	If ProcessExists($g_iSlavePID) Then Return True
	$g_iSlavePID = Run(StringFormat('%s\FlashTest-Slave%s.exe', @ScriptDir, (@AutoItX64 ? '64' : '')))
	Sleep(250)
	If Not ProcessExists($g_iSlavePID) Then Exit MsgBox(16, $sAppTitle, 'Fehler! FlashTest-Slave konnte nicht gestartet werden!', 0, $hMainGui)
EndFunc   ;==>_CheckIfSlaveExist

Func _RunTest()
	Local $aSpace, $iTestCount, $sTestFile, $sTestDir, $iMillis, $hFile, $nBytes, $iBytesDiff, $iDiff, $aRet, $iError, $iTimer, $iTimer1, $iTimer2
	Local $tBuffer, $pBuffer, $iBufferSize, $iSize, $sReadData, $iSepPos, $iDiffAsm
	$sTestDir = $g_sFlashDrive & '\FlashTest\'
	If Not FileExists($sTestDir) Then ; wenn Verzeichnis nicht vorhanden, dann erstellen
		If Not DirCreate($sTestDir) Then ; wenn das erstellen nicht geklappt hat, dann...
			_ConsoleWrite(StringFormat('Fehler: "Konnte Verzeichnis nicht erstellen!"\r\n'))
			Return
		EndIf
	EndIf
	GUICtrlSetState($idTestStartRW, $GUI_DISABLE)
	GUICtrlSetState($idTestStartR, $GUI_DISABLE)
	GUICtrlSetData($idConsole, '')
	_ConsoleWrite(StringFormat('%s v%3.3s  (%s)\r\n', $sAppTitle, $sAppVersion, (@AutoItX64 ? '64 Bit' : '32 Bit')))
	_ConsoleWrite(StringFormat('Datum: %s\r\n', _NowCalc()))
	_ConsoleWrite(StringFormat('Starte Test mit Laufwerk "%s"\r\n', $g_sFlashDrive))
	_ConsoleWrite(StringFormat('Anschluss: %s\r\n', GUICtrlRead($idBusTyp)))
	_ConsoleWrite(StringFormat('Modell: %s\r\n', GUICtrlRead($idModel)))
	_ConsoleWrite(StringFormat('Dateisystem: %s\r\n', GUICtrlRead($idFileSystem)))
	_ConsoleWrite(StringFormat('Speicher: %s\r\n', GUICtrlRead($idDriveSpace)))
	_DrawPath($idTestDisplay, '')
	$g_bStart = False
	$g_sWriteData = ''
	$g_sReadData = ''
	$g_iBytesDiff = 0
	GUICtrlSetState($idTestCancel, $GUI_ENABLE)
	GUICtrlSetData($idStartTime, 'Start: ' & _NowTime(5))
	GUICtrlSetData($idEndTime, 'Ende:')
	GUICtrlSetData($idProgress, _WinAPI_StrFormatByteSize(0))
	If $g_bReadWrite Then
		GUICtrlSetData($idProgressGroup, 'Fortschritt (schreiben)')
		GUICtrlSetData($idTestProgress, 'Testverlauf (schreiben)')
		$aSpace = _WinAPI_GetDiskFreeSpaceEx($g_sFlashDrive)
		If BitAND(GUICtrlRead($idTestSpaceSel), $GUI_CHECKED) Then
			$iTestCount = GUICtrlRead($idTestSpaceInp)
			If $iTestCount > Int($aSpace[2] / 1073741824) Then $iTestCount = Int($aSpace[2] / 1073741824)
		Else
			$iTestCount = Int($aSpace[2] / 1073741824) ; Anzahl der vollen 1-GB-Dateien
		EndIf
	Else
		Local $aFiles = _FileListToArray($sTestDir, '*.ft' & (@AutoItX64 ? '64' : '32'), $FLTA_FILES)
		If @error Then Return
		$iTestCount = $aFiles[0]
	EndIf
	GUICtrlSetData($idProgressAll, ' von ' & _WinAPI_StrFormatByteSize($iTestCount * 1073741824))
	_ConsoleWrite(StringFormat('Zum Test ausgewählt: %s\r\n', _WinAPI_StrFormatByteSize($iTestCount * 1073741824)))
	$g_bRun = True
	#Region Testdaten schreiben
	If $g_bReadWrite Then
		$iTimer = _WinAPI_GetTickCount64()
		$iTimer1 = $iTimer
		For $iCount = 1 To $iTestCount ; Anzahl der 1 GB grossen Testdateien
			$sTestFile = StringFormat('%s%06i.ft%s', $sTestDir, $iCount, (@AutoItX64 ? '64' : '32'))
			; $sTestFile an Slave schicken, Slave schreibt die Datei und schickt die einzelnen Daten zurueck
			_CheckIfSlaveExist()
			_MailSlotWrite($sMailSlotSlave, 'W1' & $sTestFile, 1)
			$iTimer2 = _WinAPI_GetTickCount64()
			While Sleep(10)
				$iSize = _MailSlotCheckForNextMessage($hMailSlot)
				If $iSize Then
					$sReadData = _MailSlotRead($hMailSlot, $iSize, 1)
					Switch StringLeft($sReadData, 2)
						Case 'CA'
							ExitLoop 2
						Case 'EN'
							ExitLoop
						Case 'E1'
							_ConsoleWrite(StringFormat('Fehler: "Konnte Datei "%s" nicht öffnen!"\r\n', $sTestFile))
							ExitLoop
						Case 'E2'
							_ConsoleWrite(StringFormat('Fehler: Ein Teil (%s) der Datei konnte nicht geschrieben werden!\r\n', StringMid($sReadData, 3)))
							ExitLoop
						Case 'RE'
							$iSepPos = StringInStr($sReadData, ',')
							$iDiffAsm = Number(StringMid($sReadData, 3, $iSepPos - 3))
							$iTimer += $iDiffAsm
							$nBytes = Number(StringMid($sReadData, $iSepPos + 1))
							$g_iBytesDiff += $nBytes
							$iMillis = _WinAPI_GetTickCount64()
							$iDiff = $iMillis - $iTimer2 - $iDiffAsm
							$g_sWriteData &= ($nBytes / 1048576) / ($iDiff / 1000) & '|'
							If $iMillis - $iTimer1 > 500 Then
								$iTimer1 = $iMillis
								GUICtrlSetData($idProgress, _WinAPI_StrFormatByteSize($g_iBytesDiff))
								GUICtrlSetData($idSpeedAvg, StringFormat('Ø %.1f MB/s', ($g_iBytesDiff / 1048576) / (($iMillis - $iTimer) / 1000)))
							EndIf
							_DrawPath($idTestDisplay, $g_sWriteData, 0xFF6622)
							$iTimer2 = $iMillis
					EndSwitch
				EndIf
			WEnd
		Next
		If $g_bStop Then
			_ConsoleWrite(StringFormat('Schreibtest abgebrochen.\r\n'))
			GUICtrlSetData($idEndTime, 'Ende: ' & _NowTime(5))
			$g_bStop = False
			$g_bRun = False
			$tBuffer = 0
			MsgBox(0, $sAppTitle, 'Schreibtest abgebrochen!', 0, $hMainGui)
			GUICtrlSetState($idTestStartRW, $GUI_ENABLE)
			GUICtrlSetState($idTestStartR, FileExists($g_sFlashDrive & '\FlashTest\000001.ft' & (@AutoItX64 ? '64' : '32')) ? $GUI_ENABLE : $GUI_DISABLE)
			Return
		EndIf
		Local $iTestSize = $iTestCount * 1073741824, $iTestMillis = _WinAPI_GetTickCount64() - $iTimer
		_ConsoleWrite(StringFormat('Zeit: %s\r\nSchreibrate: %s\r\n', _Ticks2Time($iTestMillis), GUICtrlRead($idSpeedAvg)))
		GUICtrlSetData($idProgress, _WinAPI_StrFormatByteSize($iTestSize))
;~ 		MsgBox(0, $sAppTitle, 'Schreibtest beendet!' & @CRLF & 'Mit Lesetest beginnen...', 3, $hMainGui)
		#EndRegion Testdaten schreiben
	EndIf
	#Region Testdaten lesen
	_DrawPath($idTestDisplay, '')
	GUICtrlSetData($idProgressGroup, 'Fortschritt (lesen)')
	GUICtrlSetData($idTestProgress, 'Testverlauf (lesen)')
	GUICtrlSetData($idProgress, _WinAPI_StrFormatByteSize(0))
	$g_iBytesDiff = 0
	$iTimer = _WinAPI_GetTickCount64()
	$iTimer1 = $iTimer
	For $iCount = 1 To $iTestCount ; Anzahl der 1 GB grossen Testdateien
		$sTestFile = StringFormat('%s%06i.ft%s', $sTestDir, $iCount, (@AutoItX64 ? '64' : '32'))
		; $sTestFile an Slave schicken, Slave liest die Datei und schickt die einzelnen Daten zurueck
		_CheckIfSlaveExist()
		_MailSlotWrite($sMailSlotSlave, 'R1' & $sTestFile, 1)
		$iTimer2 = _WinAPI_GetTickCount64()
		While Sleep(10)
			$iSize = _MailSlotCheckForNextMessage($hMailSlot)
			If $iSize Then
				$sReadData = _MailSlotRead($hMailSlot, $iSize, 1)
				Switch StringLeft($sReadData, 2)
					Case 'CA'
						ExitLoop 2
					Case 'EN'
						ExitLoop
					Case 'E1'
						_ConsoleWrite(StringFormat('Fehler: "Konnte Datei "%s" nicht öffnen!"\r\n', $sTestFile))
						ExitLoop
					Case 'E2'
						_ConsoleWrite(StringFormat('Fehler: Ein Teil (%s) der Datei konnte nicht gelesen werden!\r\n', StringMid($sReadData, 3)))
						ExitLoop
					Case 'E3'
						_ConsoleWrite(StringFormat('Fehler: "Fehlerhaftes DWORD an Adresse: %s"\r\n', StringMid($sReadData, 3)))
						$iError += 1
					Case 'RE'
						$iSepPos = StringInStr($sReadData, ',')
						$iDiffAsm = Number(StringMid($sReadData, 3, $iSepPos - 3))
						$iTimer += $iDiffAsm
						$nBytes = Number(StringMid($sReadData, $iSepPos + 1))
						$g_iBytesDiff += $nBytes
						$iMillis = _WinAPI_GetTickCount64()
						$iDiff = $iMillis - $iTimer2 - $iDiffAsm
						$g_sReadData &= ($nBytes / 1048576) / ($iDiff / 1000) & '|'
						If $iMillis - $iTimer1 > 500 Then
							$iTimer1 = $iMillis
							GUICtrlSetData($idProgress, _WinAPI_StrFormatByteSize($g_iBytesDiff))
							GUICtrlSetData($idSpeedAvg, StringFormat('Ø %.1f MB/s', ($g_iBytesDiff / 1048576) / (($iMillis - $iTimer) / 1000)))
						EndIf
						_DrawPath($idTestDisplay, $g_sReadData, 0x2266FF)
						$iTimer2 = $iMillis
				EndSwitch
			EndIf
		WEnd
		If $iError Then
			_ConsoleWrite(StringFormat('Achtung! Das deutet auf einen defekten Datenträger hin!\r\n'))
			$iError = 0
		EndIf
	Next
	#EndRegion Testdaten lesen
	GUICtrlSetData($idEndTime, 'Ende: ' & _NowTime(5))
	If $g_bStop Then
		_ConsoleWrite(StringFormat('Lesetest abgebrochen.\r\n'))
		$g_bStop = False
		$g_bRun = False
		$tBuffer = 0
		MsgBox(0, $sAppTitle, 'Lesetest abgebrochen!', 0, $hMainGui)
		GUICtrlSetState($idTestStartRW, $GUI_ENABLE)
		GUICtrlSetState($idTestStartR, FileExists($g_sFlashDrive & '\FlashTest\000001.ft' & (@AutoItX64 ? '64' : '32')) ? $GUI_ENABLE : $GUI_DISABLE)
		Return
	EndIf
	Local $iTestSize = $iTestCount * 1073741824, $iTestMillis = _WinAPI_GetTickCount64() - $iTimer
	_ConsoleWrite(StringFormat('Zeit: %s\r\nLeserate: %s\r\n', _Ticks2Time($iTestMillis), GUICtrlRead($idSpeedAvg)))
	_ConsoleWrite(StringFormat('Datum: %s\r\n', _NowCalc()))
	_ConsoleWrite(StringFormat('Test beendet.\r\n'))
	GUICtrlSetData($idProgress, _WinAPI_StrFormatByteSize($iTestSize))
	_SaveTestData()
	GUICtrlSetState($idTestStartRW, $GUI_ENABLE)
	GUICtrlSetState($idTestStartR, FileExists($g_sFlashDrive & '\FlashTest\000001.ft' & (@AutoItX64 ? '64' : '32')) ? $GUI_ENABLE : $GUI_DISABLE)
	GUICtrlSetState($idTestCancel, $GUI_DISABLE)
	$g_bStop = False
	$g_bRun = False
	$tBuffer = 0
EndFunc   ;==>_RunTest

Func _Ticks2Time($iTicks) ; diese Funktion, wandelt die Millisekunden (Ticks) in "hh:mm:ss.ms" um
	Local $iH, $iM, $iS, $aTime
	$iH = Int($iTicks / 3600000) ; Integerwert (Ganzzahl) der Division durch 3600000 entspricht den Stunden
	$iTicks = Mod($iTicks, 3600000) ; Modulo (Restwert) der Division durch 3600000 sind die restlichen Millisekunden
	$iM = Int($iTicks / 60000) ; Integerwert (Ganzzahl) der Division durch 60000 entspricht den Minuten
	$iTicks = Mod($iTicks, 60000) ; Modulo (Restwert) der Division durch 60000 sind die restlichen Millisekunden
	$iS = Int($iTicks / 1000) ; Integerwert (Ganzzahl) der Division durch 1000 entspricht den Sekunden
	$iTicks = Mod($iTicks, 1000) ; Modulo (Restwert) der Division durch 1000 sind die restlichen Millisekunden
	Return StringFormat('%02i:%02i:%02i.%03i', $iH, $iM, $iS, $iTicks)
EndFunc   ;==>_Ticks2Time

Func _DrawPath($iCtrl, $sData, $iColor = 0x4488EE)
	Local Static $iYValOld = 0, $iMaxOld, $iMinOld, $iTimeOld = 8
	If $sData = '' Then
		For $i = 0 To UBound($aidTestTime) - 1
			GUICtrlSetData($aidTestTime[$i], $i * 4)
		Next
		$iTimeOld = 8
	EndIf
	Local $aData, $iCount, $iMax, $iMin, $iStart = Ceiling(($iTimeOld - 8) * 64), $aPos, $iY, $iYVal, $hBitmap, $hGraphic, $hPen, $hPenGrey, $hBMP, $hPrevImage
	$aPos = ControlGetPos($hMainGui, '', $iCtrl)
	$hBitmap = _GDIPlus_BitmapCreateFromScan0($aPos[2], $aPos[3])
	$hGraphic = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	_GDIPlus_GraphicsClear($hGraphic, 0xFFFFFFFF)
	$hPen = _GDIPlus_PenCreate(0xFF000000 + $iColor, 2)
	$hPenGrey = _GDIPlus_PenCreate(0xFFAAAAAA, 1)
	$aData = StringSplit(StringTrimRight($sData, 1), '|', $STR_NOCOUNT)
	$iCount = UBound($aData)
	If Ceiling($iCount / 64) > $iTimeOld Then
		$iTimeOld = Ceiling($iCount / 64)
		For $i = 0 To UBound($aidTestTime) - 1
			GUICtrlSetData($aidTestTime[$i], ($iTimeOld - 8 + $i) * 4)
		Next
		$iCount -= 64
	EndIf
	$iCount -= $iStart
	$iMax = _ArrayMax($aData, 1)
	If $iMax <> $iMaxOld Then
		$iMaxOld = $iMax
		GUICtrlSetData($idSpeedMax, StringFormat('< %.1f MB/s', $iMax))
	EndIf
	$iMin = _ArrayMin($aData, 1)
	If $iMin <> $iMinOld Then
		$iMinOld = $iMin
		GUICtrlSetData($idSpeedMin, StringFormat('> %.1f MB/s', $iMin))
	EndIf
	$iY = $aPos[3]
	$iYVal = $iY / $iMax
	If $iYVal <> $iYValOld Then
		$iYValOld = $iYVal
		For $i = 0 To UBound($aidTestLabel) - 1
			GUICtrlSetData($aidTestLabel[$i], Ceiling($iMax / 6 * $i) & ' MB/s')
		Next
	EndIf
	For $iX = 0 To $iCount - 1
		_GDIPlus_GraphicsDrawLine($hGraphic, $iX, $iY, $iX, $iY - Int($iYVal * $aData[$iStart + $iX]), $hPen)
	Next
	For $i = 1 To UBound($aidTestLabel) - 2
		_GDIPlus_GraphicsDrawLine($hGraphic, 0, $i * 26, $aPos[2], $i * 26, $hPenGrey)
	Next
	$hBMP = _GDIPlus_BitmapCreateDIBFromBitmap($hBitmap)
	$hPrevImage = _SendMessage(GUICtrlGetHandle($iCtrl), $STM_SETIMAGE, $IMAGE_BITMAP, $hBMP)
	If $hPrevImage Then _WinAPI_DeleteObject($hPrevImage)
	_GDIPlus_PenDispose($hPen)
	_GDIPlus_PenDispose($hPenGrey)
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_BitmapDispose($hBitmap)
EndFunc   ;==>_DrawPath

Func _SwitchDrive()
	Local Const $aBusType = StringSplit('UNKNOWN,SCSI,ATAPI,ATA,1394,SSA,FIBRE,USB,RAID,ISCSI,SAS,SATA,SD,MMC,Virtual,FileBakVirtual,Spaces,NVMe,SCM,UFS,MAX,MAX Res', ',', $STR_NOCOUNT)
	Local $sDrive, $aDriveNr, $sLabel, $sTyp, $aSpace, $sTotal, $sFree, $iBus, $sModelType
	$sDrive = StringLeft(GUICtrlRead($idFlashDrive), 2)
	If $sDrive = '' Then Return
	$g_sFlashDrive = $sDrive
	$sModelType = _GetModelType($g_sFlashDrive)
	_CtrlSetState($idTestSpaceAll, $idTestSpaceLabel, $GUI_ENABLE)
	$aDriveNr = _WinAPI_GetDriveNumber($sDrive)
	$sLabel = DriveGetLabel($g_sFlashDrive)
	GUICtrlSetData($idDriveLabel, StringFormat('"%s"', $sLabel = '' ? '<keine>' : $sLabel))
	Switch DriveGetType($g_sFlashDrive)
		Case 'Fixed'
			$sTyp = 'Lokaler Datenträger'
		Case 'Removable'
			$sTyp = 'Wechseldatenträger'
	EndSwitch
	GUICtrlSetData($idDriveTyp, StringFormat('%s', $sTyp))
	GUICtrlSetData($idFileSystem, StringFormat('%s', DriveGetFileSystem($g_sFlashDrive)))
	$aSpace = _WinAPI_GetDiskFreeSpaceEx($g_sFlashDrive)
	$sTotal = _WinAPI_StrFormatByteSize($aSpace[1])
	$sFree = _WinAPI_StrFormatByteSize($aSpace[2])
	GUICtrlSetData($idDriveSpace, StringFormat('%s von %s frei', $sFree, $sTotal))
	$iBus = _WinAPI_GetDriveBusType($g_sFlashDrive)
	If $iBus < 0 Or $iBus > UBound($aBusType) - 1 Then
		MsgBox(48, $sAppTitle, StringFormat('Ein Fehler ist aufgetreten!\r\nBitte schreiben Sie dem Autor (%s) eine EMail mit diesen Daten:\r\n$iBus = %i\r\n%s.', _
				StringMid($sAppAuthorEMail, 8), $iBus, _DebugBugReportEnv()))
		$iBus = 0
	EndIf
	GUICtrlSetData($idBusTyp, $aBusType[$iBus])
	GUICtrlSetData($idModel, StringFormat('%s', $sModelType))
	GUICtrlSetState($idTestStartRW, $GUI_ENABLE)
	Local $iTestGB = _GetTestDataSize()
	GUICtrlSetState($idTestStartR, $iTestGB ? $GUI_ENABLE : $GUI_DISABLE)
	GUICtrlSetData($idTestStartR, 'Nur Lesetest' & ($iTestGB ? ' (' & $iTestGB & 'GB)' : ''))
EndFunc   ;==>_SwitchDrive

Func _GetTestDataSize()
	Local $aFiles = _FileListToArray($g_sFlashDrive & '\FlashTest\', '*.ft' & (@AutoItX64 ? '64' : '32'), 1)
	If @error Then Return 0
	Return @error ? @error : $aFiles[0]
EndFunc   ;==>_GetTestDataSize


Func _ReadFlashDrives()
	Local $aDrives = DriveGetDrive($DT_ALL), $sDrives, $aSpace, $sTotal
	For $i = 1 To $aDrives[0]
		Switch DriveGetType($aDrives[$i])
			Case 'Fixed', 'Removable'
				If DriveStatus($aDrives[$i]) = 'READY' Then
					$aSpace = _WinAPI_GetDiskFreeSpaceEx($aDrives[$i])
					$sTotal = _WinAPI_StrFormatByteSize($aSpace[1])
					$sDrives &= StringFormat('%s   %12s|', StringUpper($aDrives[$i]), $sTotal)
				EndIf
		EndSwitch
	Next
	Return StringTrimRight($sDrives, 1)
EndFunc   ;==>_ReadFlashDrives

Func _WM_NCLBUTTONDOWN($hWnd, $Msg, $wParam, $lParam)
	#forceref $hWnd, $Msg, $lParam
	Local Const $HTCAPTION = 0x2, $HTSYSMENU = 0x3, $HTTOPRIGHT = 0x14
	Switch $wParam
		Case $HTCAPTION, $HTSYSMENU ; waehrend des Tests das verschieben des Fensters abfangen
			If $g_bRun Then
				ToolTip('Während das Programm ein Laufwerk testet,' & @CRLF & 'kann das Fenster nicht verschoben werden!', Default, Default, 'Achtung!', $TIP_WARNINGICON, $TIP_BALLOON)
				AdlibRegister('_CloseToolTip', 3000)
				Return 0
			EndIf
		Case $HTTOPRIGHT ; waehrend des Tests einen Klick auf das Schliessen-Symbol als Teststop werten
			If $g_bRun Then
				_StopTest()
				Return 0
			EndIf
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NCLBUTTONDOWN

Func _CloseToolTip()
	AdlibUnRegister()
	ToolTip('')
EndFunc   ;==>_CloseToolTip

Func _WM_COMMAND($hWnd, $Msg, $wParam, $lParam)
	#forceref $hWnd, $Msg, $lParam
	Local $iIDFrom, $iCode
	$iIDFrom = _WinAPI_LoWord($wParam)
	$iCode = _WinAPI_HiWord($wParam)
	Switch $iIDFrom
		Case $idTestSpaceInp
			Switch $iCode
				Case $EN_SETFOCUS
					GUICtrlSetState($idTestSpaceSel, $GUI_CHECKED)
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_COMMAND

Func _WM_DEVICECHANGE($hWnd, $Msg, $wParam, $lParam)
	#forceref $hWnd, $Msg, $lParam
	Local $tDEV_BROADCAST_HDR, $tDEV_BROADCAST_VOLUME, $iBitmask, $sDrive
	Switch $wParam
		Case $DBT_DEVICEARRIVAL
			$tDEV_BROADCAST_HDR = DllStructCreate($tagDEV_BROADCAST_HDR, $lParam)
			Switch DllStructGetData($tDEV_BROADCAST_HDR, 'dbch_devicetype')
				Case $DBT_DEVTYP_VOLUME
					$tDEV_BROADCAST_VOLUME = DllStructCreate($tagDEV_BROADCAST_VOLUME, $lParam)
					$iBitmask = DllStructGetData($tDEV_BROADCAST_VOLUME, 'dbcv_unitmask')
					$sDrive = _BitMaskToDriveLetter($iBitmask)
					GUICtrlSetData($idFlashDrive, '')
					GUICtrlSetData($idFlashDrive, _ReadFlashDrives())
			EndSwitch
		Case $DBT_DEVICEREMOVECOMPLETE
			$tDEV_BROADCAST_HDR = DllStructCreate($tagDEV_BROADCAST_HDR, $lParam)
			Switch DllStructGetData($tDEV_BROADCAST_HDR, 'dbch_devicetype')
				Case $DBT_DEVTYP_VOLUME
					$tDEV_BROADCAST_VOLUME = DllStructCreate($tagDEV_BROADCAST_VOLUME, $lParam)
					$iBitmask = DllStructGetData($tDEV_BROADCAST_VOLUME, 'dbcv_unitmask')
					$sDrive = _BitMaskToDriveLetter($iBitmask)
					GUICtrlSetData($idFlashDrive, '')
					GUICtrlSetData($idFlashDrive, _ReadFlashDrives())
					If DriveStatus($g_sFlashDrive) <> 'READY' Then
						$g_sFlashDrive = ''
						GUICtrlSetState($idTestStartRW, $GUI_DISABLE)
						_CtrlSetState($idTestSpaceAll, $idTestSpaceLabel, $GUI_DISABLE)
						GUICtrlSetData($idDriveLabel, '')
						GUICtrlSetData($idDriveTyp, '')
						GUICtrlSetData($idFileSystem, '')
						GUICtrlSetData($idDriveSpace, '')
						GUICtrlSetData($idBusTyp, '')
					EndIf
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_DEVICECHANGE

Func _BitMaskToDriveLetter($iBitmask)
	For $i = 0 To 25
		If BitAND($iBitmask, 2 ^ $i) Then Return Chr(97 + $i) & ':'
	Next
	Return
EndFunc   ;==>_BitMaskToDriveLetter

Func _GetModelType($sDrive)
	Local Const $wbemFlagReturnImmediately = 0x10
	Local Const $wbemFlagForwardOnly = 0x20
	Local $objWMIService, $colItems = '', $aPartition, $aPhysicalDrive
	$objWMIService = ObjGet('winmgmts:\\localhost\root\CIMV2')
	If Not IsObj($objWMIService) Then Return SetError(1, 0, 0)
	$colItems = $objWMIService.ExecQuery('SELECT * FROM Win32_LogicalDiskToPartition', 'WQL', $wbemFlagReturnImmediately + $wbemFlagForwardOnly)
	If IsObj($colItems) Then
		For $objItem In $colItems
			If StringInStr($objItem.Dependent, '"' & $sDrive & '"') Then
				$aPartition = StringRegExp($objItem.Antecedent, 'DeviceID="(.*)"', 3)
			EndIf
		Next
	EndIf
	If Not IsArray($aPartition) Then Return SetError(2, 0, 0)
	$colItems = $objWMIService.ExecQuery('SELECT * FROM Win32_DiskDriveToDiskPartition', 'WQL', $wbemFlagReturnImmediately + $wbemFlagForwardOnly)
	If IsObj($colItems) Then
		For $objItem In $colItems
			If StringInStr($objItem.Dependent, '"' & $aPartition[0] & '"') Then
				$aPhysicalDrive = StringRegExp($objItem.Antecedent, 'DeviceID="(.*)"', 3)
			EndIf
		Next
	EndIf
	If Not IsArray($aPhysicalDrive) Then Return SetError(3, 0, 0)
	$aPhysicalDrive[0] = StringReplace($aPhysicalDrive[0], '\\', '\')
	$colItems = $objWMIService.ExecQuery('SELECT Model FROM Win32_DiskDrive', 'WQL', $wbemFlagReturnImmediately + $wbemFlagForwardOnly)
	If IsObj($colItems) Then
		For $objItem In $colItems
			If StringInStr($objItem.DeviceID, $aPhysicalDrive[0]) Then ExitLoop
		Next
	EndIf
	$objWMIService = ''
	Return $objItem.Model
EndFunc   ;==>_GetModelType
