﻿#include-once
#include <FontConstants.au3>
#include <SendMessage.au3>
#include <StaticConstants.au3>
#include <StructureConstants.au3>
#include <WinAPIGdi.au3>
#include <WinAPIGdiDC.au3>
#include <WinAPIGdiInternals.au3>
#include <WinAPIHObj.au3>
#include <WinAPIInternals.au3>
#include <WinAPISysInternals.au3>
#include <WinAPITheme.au3>
#include <WindowsConstants.au3>

Global Enum $PBST_NORMAL = 0, $PBST_ERROR, $PBST_PAUSED, $PBST_MIXED, $PBST_PERCENT

Func _WinAPI_ThemeSetProgress($hWnd, $iPercent, $iState = $PBST_PERCENT, $iFontSize = 14, $sFont = 'Verdana')
	Local $tRect, $tClip, $iW, $iH, $hDev, $hDC, $iRGB, $hSource, $hSv, $hFont, $hOldFont, $hTheme, $hBitmap, $hObj
	If Not IsHWnd($hWnd) Then $hWnd = GUICtrlGetHandle($hWnd)
	$tRect = _WinAPI_GetClientRect($hWnd)
	If @error Then Return
	$iW = $tRect.Right
	$iH = $tRect.Bottom
	$tClip = DllStructCreate($tagRECT)
	$tClip.Left = 1
	$tClip.Top = 1
	$tClip.Right = $iW - 1
	$tClip.Bottom = $iH - 1
	$hTheme = _WinAPI_OpenThemeData($hWnd, 'Progress')
	If @error Then Return
	$hDev = _WinAPI_GetDC($hWnd)
	$hDC = _WinAPI_CreateCompatibleDC($hDev)
	$iRGB = _WinAPI_GetThemeColor($hTheme, 1, 1, $TMT_EDGESHADOWCOLOR)
	$hSource = _WinAPI_CreateCompatibleBitmapEx($hDev, $iW, $iH, $iRGB)
	$hSv = _WinAPI_SelectObject($hDC, $hSource)
	$hFont = _WinAPI_CreateFont(-$iFontSize, 0, 0, 0, $FW_NORMAL, 0, 0, 0, $DEFAULT_CHARSET, $OUT_DEFAULT_PRECIS, $CLIP_DEFAULT_PRECIS, $PROOF_QUALITY, $DEFAULT_PITCH, $sFont)
	$hOldFont = _WinAPI_SelectObject($hDC, $hFont)
	_WinAPI_DrawThemeBackground($hTheme, 1, 1, $hDC, $tRect, $tClip)
	$tRect.Right = $iW / 100 * $iPercent
	_WinAPI_DrawThemeBackground($hTheme, 5, 1 + BitAND($iState, $PBST_MIXED), $hDC, $tRect, $tClip)
	If BitAND($iState, $PBST_PERCENT) Then _WinAPI_DrawThemeText($hTheme, 1, 1, $hDC, $iPercent & '%', $tClip, BitOR($DT_CENTER, $DT_SINGLELINE, $DT_VCENTER))
	_WinAPI_CloseThemeData($hTheme)
	_WinAPI_SelectObject($hDC, $hOldFont)
	_WinAPI_DeleteObject($hFont)
	$hBitmap = _WinAPI_CreateCompatibleBitmap($hDev, $iW, $iH)
	_WinAPI_SelectObject($hDC, $hBitmap)
	_WinAPI_DrawBitmap($hDC, 0, 0, $hSource, $MERGECOPY)
	_WinAPI_ReleaseDC($hWnd, $hDev)
	_WinAPI_SelectObject($hDC, $hSv)
	_WinAPI_DeleteObject($hSource)
	_WinAPI_DeleteDC($hDC)
	$hObj = _SendMessage($hWnd, $STM_SETIMAGE, $IMAGE_BITMAP, $hBitmap)
	If $hObj Then _WinAPI_DeleteObject($hObj)
EndFunc   ;==>_WinAPI_ThemeSetProgress
